# $1 is the file of data
# $2 is MARGIN2 or MARGIN3

set -e
set +x

data=$1
margintype=$2

#compute flip to Rep 189 from Dem 303 rneed 38
#49350 9 5483 RMARGIN2 AR 149659 50959 41857 242475

need=`cat $data | grep flip | awk '{print $NF}'`
rm -f losers
touch losers

cat $data | grep $margintype | cat > winners

if test -s winners ; then : ; else
echo NODATA $data $margintype winners `cat winners | wc -l` losers `cat losers | wc -l` need $need
exit 0
fi

#echo BEGIN $data $margintype winners `cat winners | wc -l` losers `cat losers | wc -l` need $need

cat $data | grep $margintype | while read mpop nev oscore line ; do
	echo $oscore $mpop $nev $oscore $line >> losers
done

cat losers | sort -n > losers+
mv losers+ losers

rm -f winners
touch winners

#echo SORT $data $margintype winners `cat winners | wc -l` losers `cat losers | wc -l` need $need

ewinners=0
pwinners=0

###
set +x

while test $ewinners -lt $need && test -s losers ; do

#wc -l winners losers
headline=`cat losers | sort -n | head -1`
echo $headline >> winners
tp=`echo $headline | awk '{print $2}'`
te=`echo $headline | awk '{print $3}'`
ewinners=`expr $ewinners + $te`
pwinners=`expr $pwinners + $tp`

rm -f losers+
touch losers+

cat losers | sort -n | tail +2 | while read nscore mpop nev oscore line ; do
	if test $nev -le $need ; then 
		score=`expr $mpop / $nev` ; 
	else
		score=`expr $mpop / $need` ; 
	fi
	echo $score $mpop $nev $oscore $line >> losers+
done
#wc -l winners losers+

#echo diff losers+ losers
if diff losers+ losers > /dev/null ; then : ; else
	mv losers+ losers
fi
#wc -l winners losers

cat losers | sort -n > losers+
#wc -l winners losers+

#echo diff losers+ losers
if diff losers+ losers > /dev/null ; then : ; else
	mv losers+ losers
fi
#wc -l winners losers

echo $ewinners > ewinners
echo $pwinners > pwinners

done

ewinners=`cat ewinners`
pwinners=`cat pwinners`

###

#echo

if test $ewinners -lt $need ; then
echo INFEASIBLE $data $margintype winners `cat winners | wc -l` losers `cat losers | wc -l` need $need got ev $ewinners pop $pwinners
exit 0
fi

#echo STARTPOINT $data $margintype winners `cat winners | wc -l` losers `cat losers | wc -l` need $need got ev $ewinners pop $pwinners

#cat winners

### look for removeables

excess=`expr $ewinners - $need | cat`

###

while test $excess -gt 0 ; do

rm -f extras
touch extra

cat winners | while read line ; do

nev=`echo $line | awk '{print $3}'`

if test $nev -le $excess ; then echo $line >> extras ; fi

done
 
if test -s extras ; then : ; else break ; fi

biggest=`cat extras | sort -n +1 | tail -1`

biggestp=`echo $biggest | awk '{print $2}'`
biggeste=`echo $biggest | awk '{print $3}'`

cat winners | grep -v "$biggest" > winners+
echo $biggest >> losers

#echo diff winner+ winners
if diff winners+ winners > /dev/null ; then : ; else
	mv winners+ winners
fi

ewinners=`expr $ewinners - $biggeste`
pwinners=`expr $pwinners - $biggestp`
echo $ewinners > ewinners
echo $pwinners > pwinners

excess=`expr $ewinners - $need | cat`

done

ewinners=`cat ewinners`
pwinners=`cat pwinners`

#echo AFTER-REMOVE $data $margintype winners `cat winners | wc -l` losers `cat losers | wc -l` need $need got ev $ewinners pop $pwinners

### look for replacements
set +x

echo YES > replace

while test `cat replace` = "YES" ; do

# find biggest pop vote flip

worst=`cat winners | sort -rn +1  | head -1`
#echo worst $worst
# can replace with anything with ev count -ge need - worstev
worstev=`echo $worst | awk '{print $3}'`
worstpop=`echo $worst | awk '{print $2}'`
thev=`expr $need + $worstev | cat`
thev=`expr $thev \- $ewinners | cat`
#echo worstpop $worstpop need $need +worstev $worstev mewinners $ewinners =thev $thev

cat losers | awk '{if (($3 >= '${thev}') && ($2 < '${worstpop}')) print $0}' > candidates

if test -s candidates ; then
	#echo candidates
	#cat candidates
	#echo
	leader=`cat candidates | sort -n +1 | head -1`
	#echo leader $leader

	cat losers | grep -v "$leader" > losers+
	cat winners | grep -v "$worst" > winners+
	echo $leader >> winners+
	echo $worst >> losers+
	if diff losers+ losers > /dev/null ; then : ; else
	mv losers+ losers
	fi
	if diff winners+ winners > /dev/null ; then : ; else
	mv winners+ winners
	fi
	echo YES > replace


# recompute stats

ewinners=0
pwinners=0
 
cat winners | while read nscore mpop nev oscore line ; do
ewinners=`expr $ewinners + $nev`
pwinners=`expr $pwinners + $mpop`
echo $ewinners > ewinners
echo $pwinners > pwinners
done

ewinners=`cat ewinners`
pwinners=`cat pwinners`

#echo REPLACE $data $margintype winners `cat winners | wc -l` losers `cat losers | wc -l` need $need got ev $ewinners pop $pwinners

#cat winners

else
	#echo no candidates found
	echo NO > replace
fi

done

set +x

###

echo $data $margintype 
echo
cat winners | sed 'sX^[0-9]* XX'
echo
echo needed $need electoral votes, got $ewinners 
echo flipped $pwinners popular votes

exit 0
