set -e
set +x

for year in 2020 2016 2012 2008 2004 2000 1996 1992 1980 1976 1968 1960 1948 ; do

echo
echo BEGIN $year

sh getfec-${year}.sh > getfec-${year}.log

sh state-margins.sh getfec-${year}.log > margins-${year}.log 

flipline=`grep flip margins-${year}.log`
flipevneed=`echo $flipline | awk '{print $NF}'`
rvote=`echo $flipline | awk '{print $5}'`
dvote=`echo $flipline | awk '{print $8}'`
echo $year need $flipevneed by flipping between major parties d $dvote r $rvote

flipevcount=0
flipcount=0
nline=0
echo 0 > success

# 3553 25 142 RMARGIN2 OH 1452791 1445684 37596 2936071
sh minimize-margin.sh margins-${year}.log MARGIN2

#cat  margins-${year}.log | grep MARGIN2 | sort -n +2 | while read margin nev marginperec rmargin state npd npr npt ; do
#
#echo $margin $nev $marginperec $state $npd $npr $npt
#
#flipevcount=`expr $flipevcount + $nev`
#flipcount=`expr $flipcount + $margin`
#nline=`expr $nline + 1`
#
#if test $flipevcount -ge $flipevneed ; then 
#	echo 1 > success
#	echo major party flip SUCCESS - flipped ev count $flipevcount pop count $flipcount
#echo
#echo more
#nline=`expr $nline + 1`
#cat margins-${year}.log | grep MARGIN2 | sort -n +2 | tail +${nline} | head -3  
#	break ; 
#fi

#done
#if test `cat success` = 0 ; then
#	echo major party flip FAIL
#fi

#echo

## third party margins

#echo
#flipline=`grep flip margins-${year}.log`
#flipevneed=`echo $flipline | awk '{print $NF}'`
#rvote=`echo $flipline | awk '{print $5}'`
#dvote=`echo $flipline | awk '{print $8}'`
#echo $year need $flipevneed by flipping from third parties to major d $dvote r $rvote
#
#flipevcount=0
#flipcount=0
#nline=0
#echo 0 > success
#
## 3553 25 142 RMARGIN3 OH 1452791 1445684 37596 2936071
#cat  margins-${year}.log | grep MARGIN3 | sort -n +2 | while read margin nev marginperec rmargin state npd npr npt ; do
#
#echo $margin $nev $marginperec $state $npd $npr $npt
#
#flipevcount=`expr $flipevcount + $nev`
#flipcount=`expr $flipcount + $margin`
#nline=`expr $nline + 1`
#
#if test $flipevcount -ge $flipevneed ; then 
#	echo 1 > success
#	echo third party flip SUCCESS - flipped ev count $flipevcount pop count $flipcount
#echo
#echo more
#nline=`expr $nline + 1`
#cat margins-${year}.log | grep MARGIN3 | sort -n +2 | tail +${nline} | head -3  
#	break
#fi
#
#done
#if test `cat success` = 0 ; then
#	echo third party flip FAIL
#fi

echo

done

#remove debris

rm -f trep tdem terep tedem tetot statelist statefile nstate success
rm -f ttot loser* *winner* extra candidates replace

echo DONE get-state-margins.sh

exit 0 
